{

  TIniCombo
  
  This is a decendant of Delphi component TComboBox.
  Now you are able to save your data to an INI-file and
  load it any time.
  There's one new property: INIfile
  
  To save the items to the INIfile use this method:

  IniCombo1.SaveToIni;

  When loading use:
  
  IniCombo1.LoadFromIni;


  This is freeware. Send comments to me
  
  Copyright  1998 NoComply (nocomply@as-if.com)

}

unit INIcombo;

interface

uses Messages, SysUtils, Classes, Controls, Forms, Graphics, 
     Stdctrls, IniFiles, Windows;

type
  TINICombo = class(TComboBox)
    private
        FINIfile : String;
        IniFil:TIniFile;
        procedure AutoInitialize;
        procedure AutoDestroy;
        function GetINIfile : String;
        procedure SetINIfile(Value : String);
    protected
        procedure Click; override;
        procedure KeyPress(var Key : Char); override;
        procedure Change; override;
        procedure Loaded; override;
    public
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        procedure SaveToIni;
        procedure LoadFromIni;
    published
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        property OnKeyUp;
        property OnKeyDown;
        property OnKeyPress;
        property OnEnter;
        property OnExit;
        property OnChange;
        property INIfile : String read GetINIfile write SetINIfile;
  end;

procedure Register;

implementation

procedure Register;
begin
     RegisterComponents('INIcombo', [TINICombo]);
end;

procedure TINICombo.AutoInitialize;
begin
     FINIfile := 'INIcombo.INI';
end;

procedure TINICombo.AutoDestroy;
begin
end;

function TINICombo.GetINIfile : String;
begin
     Result := FINIfile
end;

procedure TINICombo.SetINIfile(Value : String);
begin
     FINIfile := Value;
end;

procedure TINICombo.Click;
begin
     inherited Click;
end;

procedure TINICombo.KeyPress(var Key : Char);
const
     TabKey = Char(VK_TAB);
     EnterKey = Char(VK_RETURN);
begin
     inherited KeyPress(Key);
end;

procedure TINICombo.Change;
begin
     inherited Change;
end;

constructor TINICombo.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;
     IniFil:=TIniFile.Create(FIniFile);
end;

destructor TINICombo.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

procedure TINICombo.Loaded;
begin
     inherited Loaded;
end;

procedure TINICombo.SaveToIni;
var i: integer;
begin
   IniFil:=TIniFile.Create(FIniFile);
   IniFil.EraseSection('History');
   for i:=0 to Items.Count-1 do
      IniFil.WriteString('History','n'+IntToStr(i),Items[i]);
end;

procedure TINICombo.LoadFromIni;
var i: Integer;
begin
  Clear;
  IniFil:=TIniFile.Create(FIniFile);
  IniFil.ReadSection('History',Items);
  for i:=0 to Items.Count-1 do
    Items[i]:=IniFil.ReadString('History','n'+IntToStr(i),'');
end;


end.
